# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global python_version %(python -c "import sys; print sys.version[:3]" 2>/dev/null || echo none)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{python_version}/site-packages}
%global noarch_subpkg %([ "%{__distinit}" == "fc" -a %{__distvers} -gt 9 -o "%{__distinit}" == "rhel" -a %{__distvers} -gt 5 ] && echo 1 || echo 0)

Name:		xxdiff
Version:	4.0.1
Release:	1.0.cf.%{__distinit}%{__distvers}
Group:		Applications/Text
License:	GPLv2+
Summary:	Graphical file and directories comparator and merge tool
URL:		http://furius.ca/xxdiff/
# The original tarball can be found at http://downloads.sf.net/xxdiff/xxdiff-4.0.tar.bz2
# This tarball has the doc/screenshots directory removed as the images in that directory
# cannot be redistributed without permission
Source0:	xxdiff-%{version}-noscreenshots.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	bison
BuildRequires:	coreutils
BuildRequires:	flex >= 2.5.31
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	python2-devel >= 2.4
BuildRequires:	qt4-devel >= 4.5
BuildRequires:	sed

%description
xxdiff is a graphical browser for viewing the differences between two or three
files, or between two directories, and can be used to produce a merged version.

%package tools
Summary:	Useful scripts built around xxdiff
Group:		Applications/Text
Requires:	%{name} = %{version}-%{release}
%if %{noarch_subpkg}
BuildArch:	noarch
%endif

%description tools
This package provides a number of scripts that are used to perform a variety of
tasks that all involve getting user verification and feedback using the xxdiff
graphical differences viewer.

%prep
%setup -q

# Fix shellbang for combined script/module
sed -i -e 's|^#!/usr/bin/env python$|#!/usr/bin/python2|' \
	lib/python/xxdiff/scripts/svnforeign.py

%build
cd src
make -f Makefile.bootstrap QMAKE=qmake-qt4
make %{_smp_mflags} CFLAGS="%{optflags}" CXXFLAGS="%{optflags}"
cd -

# Python tools
python setup.py build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir}
install -m 755 bin/xxdiff %{buildroot}%{_bindir}

# Python tools
python setup.py install -O1 --skip-build --root %{buildroot}

# svnforeign.py is also a standalone executable
chmod -c +x %{buildroot}%{python_sitelib}/xxdiff/scripts/svnforeign.py

# See if there's any egg-info
if [ -f %{buildroot}%{python_sitelib}/xxdiff*.egg-info ]; then
	echo %{buildroot}%{python_sitelib}/xxdiff*.egg-info |
		sed -e 's|^%{buildroot}||'
fi > egg-info

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license COPYING
%else
%doc COPYING
%endif
%doc doc index.html
%doc CHANGES README TODO VERSION
%{_bindir}/xxdiff

%files -f egg-info tools
%{python_sitelib}/xxdiff/
%{_bindir}/svn-foreign
%{_bindir}/xx-cond-replace
%{_bindir}/xx-cvs-diff
%{_bindir}/xx-cvs-revcmp
%{_bindir}/xx-diff-proxy
%{_bindir}/xx-encrypted
%{_bindir}/xx-filter
%{_bindir}/xx-find-grep-sed
%{_bindir}/xx-hg-merge
%{_bindir}/xx-match
%{_bindir}/xx-p4-unmerge
%{_bindir}/xx-pyline
%{_bindir}/xx-rename
%{_bindir}/xx-sql-schemas
%{_bindir}/xx-svn-diff
%{_bindir}/xx-svn-resolve
%{_bindir}/xx-svn-review

%changelog
* Sun May 22 2016 Paul Howarth <paul@city-fan.org> - 4.0.1-1.0.cf
- Cumulative bug fix update
- Drop upstreamed bison3 patch
- Use %%license where possible
- New tool script: xx-p4-unmerge

* Wed Oct 22 2014 Paul Howarth <paul@city-fan.org> - 4.0-2.0.cf
- Fix build with bison 3 (http://sourceforge.net/p/xxdiff/bugs/229/)

* Thu Aug  8 2013 Paul Howarth <paul@city-fan.org> - 4.0-1.0.cf
- Update to 4.0 (major update to Qt4)
- Drop gcc patches, no longer needed
- Drop support for old python versions as everywhere that has Qt ≥ 4.5 also
  has python ≥ 2.5
- Never need flex-new as everywhere that has Qt ≥ 4.5 also has flex ≥ 2.5.31
- Drop %%defattr, redundant since rpm 4.4

* Mon Aug  5 2013 Paul Howarth <paul@city-fan.org> - 3.2-20.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Feb 23 2013 Paul Howarth <paul@city-fan.org> - 3.2-19.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jul 24 2012 Paul Howarth <paul@city-fan.org> - 3.2-18.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu May  3 2012 Paul Howarth <paul@city-fan.org> - 3.2-17.0.cf
- Fix FTBFS with gcc 4.7

* Mon Aug  1 2011 Paul Howarth <paul@city-fan.org> - 3.2-15.0.cf
- BR: python2-devel rather than just python-devel
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Mon Feb 14 2011 Paul Howarth <paul@city-fan.org> - 3.2-14.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> - 3.2-13.1.cf
- Rebuild for python 2.7 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> - 3.2-13.0.cf
- Rebuild for RHEL-6

* Mon Feb 22 2010 Paul Howarth <paul@city-fan.org> - 3.2-12.0.cf
- Dist tag for Rawhide no longer needs special-casing

* Fri Jul 31 2009 Paul Howarth <paul@city-fan.org> - 3.2-11.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 17 2009 Paul Howarth <paul@city-fan.org> - 3.2-10.0.cf
- Start building for current Fedora releases again
- Strip non-distributable screenshots from tarball
- Use %%{optflags} in all builds
- Fix the multitude of warnings about string constants converted to 'char*'
- Make the tools subpackage arch-independent on Fedora 10 onwards
- Try to fix the remaining python 2.2/2.3 compatibility issues
- Add buildreq XFree86-devel for RHL9/FC1 (missing dep of qt3-devel)

* Sun Jun 22 2008 Paul Howarth <paul@city-fan.org> - 3.2-6
- Add note about no longer building for recent Fedora versions since
  xxdiff is now included in Fedora

* Wed Apr 23 2008 Paul Howarth <paul@city-fan.org> - 3.2-5
- Buildrequire qt3-devel on Fedora 9 onwards
- Replace C headers with C++ versions where necessary
- Include python egg-info where available

* Wed Nov  7 2007 Paul Howarth <paul@city-fan.org> - 3.2-4
- Fix dist tag for Fedora 7 onwards
- Clarify license as GPL version 2 or later
- Buildreq and use flex rather than flex-new for Fedora 7 onwards

* Mon Dec 11 2006 Paul Howarth <paul@city-fan.org> - 3.2-3
- Fixup build in mock with no python in initial buildroot
- Don't %%ghost .pyo files

* Tue Sep 12 2006 Paul Howarth <paul@city-fan.org> - 3.2-2
- Fix dist tag for development builds
- Add python-devel buildreq for tools subpackage

* Mon Jul  3 2006 Paul Howarth <paul@city-fan.org> - 3.2-1
- Update to 3.2
- Tag builds on CentOS and Whitebox as RHEL
- New URL
- tmake no longer needed, but flex-new is
- Major spec rewrite due to significant upstream changes
- Put tools in separate subpackage

* Tue Jun 21 2005 Paul Howarth <paul@city-fan.org> - 3.1-2
- Set TMAKEPATH explicitly before building
- Don't use a specific sf.net mirror for SOURCE0 URL
- Fix build for 3.3 > qt ≥ 3.0

* Thu Mar 31 2005 Paul Howarth <paul@city-fan.org> - 3.1-1
- Initial RPM build
